/*
   Convenience functions related to allocation.
*/

#include <mlvalues.h>
#include <alloc.h>
#include <fail.h>
#include <stdlib.h>

char * stat_alloc (size_t sz)
{
  char * result = (char *) malloc (sz);

  if (result == NULL) raise_out_of_memory ();
  return result;
}

void stat_free (char * blk)
{
  free (blk);
}

value alloc_array(value (*funct)(char*), char **arr)
{
  mlsize_t nbr, n;
  value v;

  nbr = 0;
  while (arr[nbr] != 0) nbr++;
  if (nbr == 0) {
    v = atom(0); /* vecteur nul */
  } else {
    v = make_vector(nbr, KFALSE);
    for (n = 0; n < nbr; n++)
      Field(v,n) = funct(arr[n]);
  }
  return v;
}

value copy_string_array(char **arr)
{
  return alloc_array((value (*) ())copy_string, arr);
}

int convert_flag_list(value list, int *flags)
{
  int res;
  res = 0;
  while (list) {
    res |= flags[CINT(Field_tuple(list, 0))];
    list = Field_tuple(list, 1);
  }
  return res;
}
